//--------------------------------------------------------------------
#property indicator_separate_window 
#property indicator_buffers 3       
#property indicator_color1 Red      
#property indicator_color2 Blue     
#property indicator_color3 DarkGreen     

double Buf_1[],Buf_2[],Buf_3[];    
double CurrentPoint1, CurrentPoint2, ZeroClose1, ZeroClose2;
                       
extern string Symbol1_Name = "EURUSD"; //   1
extern string Symbol2_Name = "USDJPY"; //   2
extern bool   Revers = true;           // true  -    
                                       // false -    
extern color  level_color = Black;     //    
extern double level1 = 20;             //   1 
extern double level2 = 40;             //   2
extern double level3 = 60;             //   3

string Text_1,Text_2,Text_3;  
//--------------------------------------------------------------------
int init()                          
  {
//--------------------------------------------------------------------
   IndicatorBuffers(3);

   SetIndexBuffer(0,Buf_1);        
   SetIndexStyle (0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexLabel (0,Symbol1_Name); 
   
   SetIndexBuffer(1,Buf_2);         
   SetIndexStyle (1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexLabel (1,Symbol2_Name); 

   SetIndexBuffer(2,Buf_3);        
   SetIndexStyle (2,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexLabel (2,"Spread"); 
   
   SetLevelStyle(STYLE_DOT,1,Black);
   SetLevelValue(1,0);
   SetLevelValue(2,level1);
   SetLevelValue(3,level2);
   SetLevelValue(4,level3);
   SetLevelValue(5,-level1);
   SetLevelValue(6,-level2);
   SetLevelValue(7,-level3);

   Create(Time[10]);
   Create_RSI();
//--------------------------------------------------------------------  
   return;                         
  }
//--------------------------------------------------------------------
int start()                         
  {
   datetime T1;
   int i; 
//--------------------------------------------------------------------
   T1=ObjectGet(WindowExpertName(),OBJPROP_TIME1);   
   i=iBarShift(Symbol1_Name,0,T1);           
   ZeroClose1 = iClose(Symbol1_Name,Period(),iBarShift(Symbol1_Name,0,Time[i])); 
   ZeroClose2 = iClose(Symbol2_Name,Period(),iBarShift(Symbol2_Name,0,Time[i]));
   CurrentPoint1 = 0;
   CurrentPoint2 = 0;   
   ArrayInitialize(Buf_3,EMPTY_VALUE); 
   ArrayInitialize(Buf_1,EMPTY_VALUE); 
   ArrayInitialize(Buf_2,EMPTY_VALUE); 
   while(i>=0)                     
     {
      CurrentPoint1 = CurrentPoint1 + (iClose(Symbol1_Name,Period(),iBarShift(Symbol1_Name,0,Time[i])) - ZeroClose1);
      if(Revers)CurrentPoint2 = CurrentPoint2 - (iClose(Symbol2_Name,Period(),iBarShift(Symbol2_Name,0,Time[i])) - ZeroClose2);
      else CurrentPoint2 = CurrentPoint2 + (iClose(Symbol2_Name,Period(),iBarShift(Symbol2_Name,0,Time[i])) - ZeroClose2);
      
      ZeroClose1 = iClose(Symbol1_Name,Period(),iBarShift(Symbol1_Name,0,Time[i]));
      ZeroClose2 = iClose(Symbol2_Name,Period(),iBarShift(Symbol2_Name,0,Time[i]));
      
      Buf_1[i] = CurrentPoint1  / MarketInfo(Symbol1_Name, MODE_POINT);
      Buf_2[i] = CurrentPoint2  / MarketInfo(Symbol2_Name, MODE_POINT);
      Buf_3[i] = (CurrentPoint1 / MarketInfo(Symbol1_Name, MODE_POINT) - CurrentPoint2 / MarketInfo(Symbol2_Name, MODE_POINT));
      i--;                         
     }
   if(CurrentPoint1>CurrentPoint2) 
      {
       Text_1 = Symbol1_Name+" Sell";
       if(Revers)Text_2 = Symbol2_Name+" Sell";
       else Text_2 = Symbol2_Name+" Buy";
      }
   if(CurrentPoint1<CurrentPoint2) 
      {
       Text_1 = Symbol1_Name+" Buy";
       if(Revers)Text_2 = Symbol2_Name+" Buy";
       else Text_2 = Symbol2_Name+" Sell";
      }
   Text_3 = "Spread = " + DoubleToStr(CurrentPoint1/MarketInfo(Symbol1_Name, MODE_POINT)- 
                                          CurrentPoint2/MarketInfo(Symbol2_Name, MODE_POINT),0);  
      
   ObjectSetText(WindowExpertName()+"1",Text_1,11,"Arial",Red);
   ObjectSetText(WindowExpertName()+"2",Text_2,11,"Arial",Blue);
   ObjectSetText(WindowExpertName()+"3",Text_3,11,"Arial",DarkGreen);
//--------------------------------------------------------------------
   return;                          
  }
//--------------------------------------------------------------------
int deinit()                   
  {
   //ObjectsDeleteAll(-1, OBJ_VLINE); 
   ObjectDelete("Obj_RSI_1");   
   ObjectDelete("Obj_RSI_2");  
   ObjectDelete("Obj_RSI_3");      
   return;                             
  }
//-------------------------------------------------------------------- 
int Create(datetime TimeL)                          
  {                                   
   ObjectCreate(WindowExpertName(), OBJ_VLINE, 0, TimeL, 0);
   ObjectSet(   WindowExpertName(), OBJPROP_COLOR, Red);   
   ObjectSet(   WindowExpertName(), OBJPROP_STYLE, DRAW_LINE);
   ObjectSet(   WindowExpertName(), OBJPROP_WIDTH, 1);
   WindowRedraw();                     
  }
//-------------------------------------------------------------------- 
int Create_RSI()                        
  {                                             
   ObjectCreate(WindowExpertName()+"1",OBJ_LABEL, WindowFind(WindowExpertName()), 0, 0); 
   ObjectSet(WindowExpertName()+"1",   OBJPROP_CORNER, 0);     
   ObjectSet(WindowExpertName()+"1",   OBJPROP_XDISTANCE, 5);  
   ObjectSet(WindowExpertName()+"1",   OBJPROP_YDISTANCE,20);  
   
   ObjectCreate(WindowExpertName()+"2",OBJ_LABEL, WindowFind(WindowExpertName()), 0, 0); 
   ObjectSet(WindowExpertName()+"2",   OBJPROP_CORNER, 0);     
   ObjectSet(WindowExpertName()+"2",   OBJPROP_XDISTANCE, 5);  
   ObjectSet(WindowExpertName()+"2",   OBJPROP_YDISTANCE,40);
   
   ObjectCreate(WindowExpertName()+"3",OBJ_LABEL, WindowFind(WindowExpertName()), 0, 0); 
   ObjectSet(WindowExpertName()+"3",   OBJPROP_CORNER, 0);     
   ObjectSet(WindowExpertName()+"3",   OBJPROP_XDISTANCE, 5);  
   ObjectSet(WindowExpertName()+"3",   OBJPROP_YDISTANCE,60);   
    
   WindowRedraw();
  }
//------------------------------------------------------------------